;20030729, Arthur de Beun, modified for WINAVR

.text
#if defined (__AVR_ATmega8__) || defined (__AVR_ATmega16__) || defined (__AVR_ATmega32__) || defined (__AVR_ATmega64__)
#define SPMCR (0x57)
#elif defined (__AVR_ATmega128__)
#define SPMCR (0x68)
#endif


; void write_page (unsigned int adr, unsigned char function);
; bits 8:15 adr addresses the page...(must setup RAMPZ beforehand!!!)
.global write_page
write_page:
        RCALL WAIT_SPMEN
        MOV R31,R25
        MOV R30,R24         ;move address to z pointer (R31=ZH R30=ZL)
        STS SPMCR,R22       ;argument 2 decides function
        SPM                 ;perform pagewrite
        RET

; void fill_temp_buffer (unsigned int data, unsigned int adr);
; bits 7:1 in adr addresses the word in the page... (2=first word, 4=second word etc..)
.global fill_temp_buffer
fill_temp_buffer:
        RCALL WAIT_SPMEN
        MOV R31,R23
        MOV R30,R22         ;move address to z pointer (R31=ZH R30=ZL)
        MOV R1,R25
        MOV R0,R24          ;move data to reg 0 and 1
        LDI R19,0x01
        STS SPMCR,R19
        SPM                 ;Store program memory
        clr R1              ;must set R1 to zero for WINAVR
        RET

;unsigned int read_program_memory (unsigned int adr ,unsigned char cmd);
.global read_program_memory
read_program_memory:
        MOV R31,R25         ;R31=ZH R30=ZL
        MOV R30,R24         ;move adress to z pointer
        SBRC R22,0          ;read lockbits? (second argument=0x09)
        STS SPMCR,R22       ;if so, place second argument in SPMEN register
        LPM                 ;read LSB
        MOV R24,R0
        INC R30
        LPM
        MOV R25,R0          ;read MSB (ignored when reading lockbits)
        RET

.global enableRWW
enableRWW:
        RCALL WAIT_SPMEN
        LDI R27,0x11
        STS SPMCR,R27
        SPM
        RET

WAIT_SPMEN:
        LDS     R27,SPMCR   ;load SPMCR to R27
        SBRC    R27,0       ;check SPMEN flag
        RJMP    WAIT_SPMEN  ;wait for SPMEN flag cleared        
        RET

;delay routine
;used to be a for loop written in C, but it gets optimised away, so write in asm instead
.global fv_wait
fv_wait:
        ldi r26, 0xFF		;1
        ldi r27, 0x7C		;1
        sbiw    r26, 1		;2
        sbrs    r27, 7		;2
        rjmp    .-6			;2
        ret

